#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
# !+-------------------------------------------------------------------------
#    Name:  dbamon_tag.pl
# !*-------------------------------------------------------------------------

$| = 1;
$P = "dbamon_tag.pl";
use DBI;
require "cgi_handlers.pl";

$debug = 0;

# Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}
$font = "consolas" if ! $font;

push(@INC,"/opt/dbamon/lib");
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

$fs = "<font size=2>";
$fe = "</font>";

# General parms required
$DBdir         = "/var/opt/apache/htdocs/cftasks";
$modlockfile   = "$DBdir/modlock";
$entlockfile   = "$DBdir/entlock";
$conlockfile   = "$DBdir/conlock";
$modfile       = "$DBdir/modEntries";
$cfteamFile    = "$DBdir/cfteam";
$entityFile    = "$DBdir/entities";

$data_source = "dbi:mysql";
$database = "dbamon";

# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

$dbms = "oracle";

# See if DBAmon is configured to use Oracle
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
  $dbms = "oracle";
}

#-----------------------------------------------------------------------------
sub errorOld
#-----------------------------------------------------------------------------
{
  local($errorMsg,@error_fields) = @_;

  &msg("Here"); 

  #print "Content-type: text/html\n\n";
  print "<head><title> Database Function Error - Output</title></head>";
  print "<body>";

  print "<h3> The following database error occured - $date<hr></h3>";
  print "</hr noshade>";
  print "<h4> $errorMsg $DBI::errstr</h4>";
  print "SQL statement: <pre>$statement</pre>";

  &PrintLinks;

  print "</body>";
  print "</html>";

  $emsg = $_[0];
  $sqlerror = $DBI::errstr;
  print "==========================================\n";
  print "Fatal Error: $emsg - $sqlerror\n";
  print "==========================================\n";
  chop($admin_email = `grep Admin_EMail: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
  system("echo \"$P - DBAmon Master Server: $hostname\" | mailx -s \"DBAmon Fatal Error: $P - $emsg - $sqlerror\" $admin_email");

  exit(1);
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  ##print "</center><br><font size=2>$date ${P} | <b>$msgmsg</b></font><center>\n";
  print "<br><span style='font-family:consolas;font-size:10pt;'><font size=2>$date ${P} | <b>$msgmsg</b></font>\n";
}

#-----------------------------------------------------------------------------
sub error_check
#-----------------------------------------------------------------------------
{
  if ($rqpairs{'initials'} eq "")
  {
     push (@error_list, "Initials must not be blank\n");
  }
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
   local($Signal) = @_;
   close(you_fill_in_the_file_descriptor);
   unlink($you_fill_in_the_tmp_file_name);
   exit(0);
}

#-----------------------------------------------------------------------------
sub error_html 
#-----------------------------------------------------------------------------
{
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str4="<h4>Insufficient or Missing Information:<hr></h4>";
   $html_str=$str.$str1.$str2.$str1.$str4;
   print "$html_str\n";
   print "<h5>Please correct the following:</h5>";
   print "<p>$fs\n";
   print "<ul>\n";
   foreach( @error_list) 
   {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors correction(s) to make.<p>\n";
   }
   print "<hr>Click <b>BACK</b> and try again.\n";
      
}

#-----------------------------------------------------------------------------
sub create_form 
#-----------------------------------------------------------------------------
{
  print "
  <font size=2>
  <p>
  <hr>
  <font color=darkblue>
  <b>
  This transaction allows you to update the \"Tag\" text on the Instance Summary. 
  <br>It will take a few minutes for it to be updated on the WWW page. 
  </font>
  <hr>
  ";

  print "<FORM method='POST' action='/cgi-bin/dbamon_tag.pl?$instance,UPDATE'>";
  print "
    <p> <form> 
    <table bgcolor=lightsteelblue border=1>

    <TR>
      <th bgcolor=slate>
        <B>$fs Your Initials $fe <font size=1>(2 Characters Max.):
      <TD>
        <INPUT type=text size=2 maxlength=2 name=initials value=\"$initials\"> 
    <TR>
      <th bgcolor=slate>
        <B>$fs Tag Text$fe <font size=1>(10 Characters Max.):
      <TD>
        <INPUT type=text size=10 maxlength=10 name=text value=\"$text\"> 
  ";

  print "</table> </b><p> <HR> 
  $fs Click Here to Save Changes: $fe
  <b><INPUT type=submit value=\"Save Changes\"></input></b>
  <hr>
  <INPUT TYPE=HIDDEN NAME=instance value=\"$instance\">
  </CENTER></form>
  <!--#include virtual=\"/solutions/dba/misc/foot.html\"-->
  ";
}

#-----------------------------------------------------------------------------
sub connectDBOld
#-----------------------------------------------------------------------------
{
  # Connect to the Mysql database
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
         &error('Failed_on_DB_connect_in_updateDb');
}

#-----------------------------------------------------------------------------
sub selectData
#-----------------------------------------------------------------------------
{
  # Create the SQL SELECT statement
  if ($debug)
  {
    $z = `env | grep ^DBA`; 
    &msg("DEBUG - dbamon_repos=$dbamon_repos - env: $z"); 
  }

  if ($dbamon_repos eq "O") 
  {
    $sql  = "
    select 
      to_char(ts,'YYYYMMDDHH24MISS'),
      text,
      initials
    from tag 
    where 
     instance = '$instance'";
  }
  else
  {
    $sql  = "
    select 
      dbamon.dateconvert_19(ts),
      text,
      initials
    from dbamon.tag 
    where 
     instance = '$instance'";
  }
 
  &msg("sql=$sql");

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute              || &error('Failed_on_DB_execute_in_chgEnt');

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $ts       = $Data[0];
    $text     = $Data[1];
    $initials = $Data[2];
    $selectcount++;
  }

  &msg("selected: ts=$ts text=$text initials=$initials");
}

#-----------------------------------------------------------------------------
sub init_values 
{
  $dateraw = `date +%Y%m%d%H%M%S`;

  $yyyy = substr($dateraw,0,4);
  $mm   = substr($dateraw,4,2);
  $dd   = substr($dateraw,6,2);
  $hour = substr($dateraw,8,2);
  $min  = substr($dateraw,10,2);

  $s_yyyy = $yyyy;
  $s_mm   = $mm;
  $s_dd   = $dd;
  $s_hh   = $hour;
  $s_min  = $min;

  $e_yyyy = $yyyy;
  $e_mm   = $mm;
  $e_dd   = $dd;
  $e_hh   = 23;
  $e_min  = 59;

  $reason = "";
  $user   = "";
}


#-----------------------------------------------------------------------------
sub custom_html 
{
   print "<h1>Thank you for using this input form.</h1>";
   print "<h2>Your request has been sent.</h2>";
   print "<p><hr>\n";
}

#
# Attempt to make sure that no meta characters are entered in the form.
#
#-----------------------------------------------------------------------------
sub CheckForEvilness
{
  local($woid2check) = @_;
  if (($woid2check =~ /\//) ||
      ($woid2check =~ /\;/) ||
      ($woid2check =~ /\</) ||
      ($woid2check =~ /\>/) ||
      ($woid2check =~ /\*/) ||
      ($woid2check =~ /\|/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\&/) ||
      ($woid2check =~ /\!/) ||
      ($woid2check =~ /\#/) ||
      ($woid2check =~ /\(/) ||
      ($woid2check =~ /\)/) ||
      ($woid2check =~ /\[/) ||
      ($woid2check =~ /\]/) ||
      ($woid2check =~ /\{/) ||
      ($woid2check =~ /\}/) ||
      ($woid2check =~ /\:/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\//) ||
      ($woid2check =~ /\n/) ||
      ($woid2check =~ /\"/))
        {
          print "Content-type: text/html\n\n";
          print "You have entered spurious control characters in a field.\n";
          print "You cannot use any of the following characters:\n";
          print " ;<>*|\'&!#()[]{}:\'/\"";
          print "\n The entry that is suspect is [$woid2check]\n";
          print "Please retry...\n";
          exit;
         }
}

#-----------------------------------------------------------------------------
sub deleteData
{
  $statement  = "delete from dbamon.tag where instance = '$instance'";

  #print "statement=$statement\n";
  #system("id");

  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_delete');

  ##print "<h3>Instance: <font color=blue> $instance </font><hr></h3>\n";
  &msg("All data deleted for this instance");
}

#-----------------------------------------------------------------------------
sub insertData
{
  $text     = $rqpairs{'text'};
  $initials = $rqpairs{'initials'};

  # Remove naughty characters
  $reason   =~ s/'/"/g;
  $instance =~ s/'/"/g;

  $statement  = "insert into dbamon.tag (instance,initials,text) values ";
  $statement .= "(\'$instance\', \'$initials\',\'$text\')";

  &msg("statement=$statement");
  #system("id");

  #print "test2a\n";
  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_insert');
  #print "test2b rc=$rc\n";

  $insertcnt++;
  
  &msg("The following data has been inserted:");
  &msg("text=$text initials=$initials");
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

##system("echo '' | mailx -s 'monitor--$P [AUTO]' bbcolo22\@gmail.com");

$instance = (split(",",$ARGV[0])) [0];
$verb     = (split(",",$ARGV[0])) [1];

print "Content-type: text/html\n\n
  <title>DBAmon Tag Edit</title>
  <body bgcolor=white link=darkblue vlink=darkblue><font face=$font>
  <table width=700><tr><td><img src='/dbamon/img/dbamonlogo.jpg' width=700>
  <tr bgcolor=wheat><td><font face=$font size=5>
      <center>Tag Edit - $instance</center>
  </table>";

&msg("Starting - instance=$instance verb=$verb");

$tempfl = "/tmp/dbamon_tag.txt";

$SaveFile = "/tmp/dbamon_tag.log";
unlink($SaveFile);
chop($CurrentDate = `date`);
open(LOG, ">>$SaveFile" );
print LOG "$CurrentDate : filename=$filename\n";

#
# Get form data
#
&get_request;

&connectDB;

&msg("verb=$verb") if $debug;
if ($verb eq "UPDATE")
{
  &error_check;

  if (@error_list != 0)
  {
    print LOG "Encountered errors\n";
    &error_html;
    exit 1;
  }
  print LOG "No errors\n";

  &deleteData;
  &insertData;

  $goback = "-2"; 
  print "<script language='JavaScript'> function back() { history.go($goback); } </script>";
  print "<hr>$fs<b>To return to the Instance Summary, \n";
  print "<a href='javascript:back()'>Click Here</a>";

  close(LOG);
  exit 0;
}

#
# Read data in table for this instance
#
&selectData;

#
# Init date values
#
if ($ts eq "")
{
  &init_values;
}

#
# Print finished form
#
&create_form;

close(LOG);
exit 0;
