#-------------------------------------------------------------------------------
sub DownloadSWWin
#-------------------------------------------------------------------------------
#
{
  ($thishost) = @_;
  &logit("In DownloadSWWin.pl", $thishost); 

  #---- Vars
  my $filemask = ""; 
  my $local_debug = 0; 

  &debug($thishost,"BEFORE - This probe=$probe[$thishost]"); 

  #---- Copy SQLREQFILE to create REQUIRE FILE
  &sqlReqFile;
  if    ($dbms[$i_rm] eq "MSSQL")    { &sqlReqFile;  } 
  elsif ($dbms[$i_rm] eq "OSWin")    { &osWinReqFile; } 

  #---- $using_copssh=1 if we're only using COPSSH
  $using_copssh = 1; 
  $using_copssh_singlethread = 0; 
  $openssh[$thishost] = 1; 
  #---- If we are using COPSSH, set this manually
  ##$openssh[$thishost] = 1 if $using_copssh;

  if (! $using_copssh)
  {
    #---- Do this every iteration !!!
    #---- Get a list of the services running
    &logit("Listing running services",$thishost);
    print "DownloadSWWin - $titleraw[$thishost] | Performing NET START\n"; 
    &remsh("net start",$tmpfl2,$thishost);
    system("cat $tmpfl2") if $local_debug; 
    my $services_list = `cat $tmpfl2`;
    if ($services_list =~ /OpenSSH/i)
    {
      $openssh[$thishost] = 1;
      if    ($dbms[$i_rm] eq "MSSQL")    { $probe[$thishost] = 'dbamon_mssql.pl'; } 
      elsif ($dbms[$i_rm] eq "OracleNT") { $probe[$thishost] = 'dbamon_orant.pl'; } 
      elsif ($dbms[$i_rm] eq "OSWin")    { $probe[$thishost] = 'dbamon_oswin.pl'; } 

      &debug($thishost,"This server runs OpenSSH - probe=$probe[$thishost]"); 
    }
    else
    {
      $openssh[$thishost] = 0;
      &debug($thishost,"This server does NOT run OpenSSH"); 
    }
  }

  &logit("Using probe=$probe[$thishost]", $thishost); 

  #---- Remove any old /tmp/dbamon* files - NOT needed if you're using COPSSH
  if (! $using_copssh)
  {
    &logit("(DEBUG) Removing old download files",$thishost);
    if ($comm_method[$thishost] eq "ssh")
    {
      $must_connect = 0;
      ##print "DEBUG - rming ssh temp\n";
      &remsh("rm -f \\\\temp\\\\dbamon*.pl",$tmpfl2,$thishost);

    }
    else
    {
      $must_connect = 1;
      &remsh("erase \\temp\\dbamon*.pl",$tmpfl2,$thishost);
    }
  }

  #---- This doesn't make sense - we haven't yet set $up
  #if ($up[$thishost] eq "N")     # Remsh error
  #{
  #  &logit("(Connect Error) - turning off download flag",$thishost);
  #  $up[$thishost] = "D";
  #  $download_flag[$thishost] = 0;
  #  return;
  #}

  #
  # Until an rcp bug is fixed we have to remsh to server and then rcp the
  # S/W back to \temp
  #
  # Download pgms from /opt/dbamon/bin/download to temp
  #
  if ($dbms[$thishost] eq "MSSQL")    { $filemask = "mssql" }
  if ($dbms[$thishost] eq "OracleNT") { $filemask = "orant" }
  if ($dbms[$thishost] eq "OSWin")    { $filemask = "oswin" }

  #---- This is to prevent strange errors below
  unlink "$tmpfl2" if -e "$tmpfl2";
  system("touch $tmpfl2");

  if ($ntrcpbug[$thishost] eq "Y")
  {
    $cmd = "remsh $hostname[$thishost] 'rcp ${wsnamef}.${dbamon_userid}:/opt/dbamon/bin/download/*$filemask* .' 2>&1 | grep -v '^\$' > $tmpfl2";
    $rc = system($cmd);
    ## $cmd = "remsh $hostname[$thishost] 'move *${filemask} \\temp\\dbamon_${filemask}.pl' 2>&1 | grep -v '^\$' >> $tmpfl2 2>&1";
    $cmd = "remsh $hostname[$thishost] 'move *${filemask}* \\temp' 2>&1 | grep -v '^\$' >> $tmpfl2 2>&1";
    $rc = system($cmd);
    ##print "rc=$rc cmd=$cmd\n";
  }
  else
  {
    if ($comm_method[$thishost] eq "ssh")
    {
      if ($openssh[$thishost] == 1)
      {
        #---- COPSSH Uses this one - to local home dir on TARGET
        ##$cmd = "scp /opt/dbamon/bin/download/*${filemask}* $tmpdir/dbamon_mssql_req.pl '$userid[$thishost]\@$hostname[$thishost]:' 2>&1 | grep -v '^\$' > $tmpfl2 2>&1";
        ##$cmd = "scp /opt/dbamon/bin/download/*${filemask}* $tmpdir/$reqfile[$thishost] '$userid[$thishost]\@$hostname[$thishost]:' 2>&1 | grep -v '^\$' > $tmpfl2 2>&1";
        $cmd = "scp /opt/dbamon/bin/download/*${filemask}* $tmpdir/$reqfile[$thishost] '$userid[$thishost]\@$hostname[$thishost]:' > $tmpfl2 2>&1";
        ##print "HIT cmd=($cmd)\n"; 
      }
      else
      {
        $cmd = "scp /opt/dbamon/bin/download/*${filemask}* $tmpdir/dbamon_mssql_req.pl '$userid[$thishost]\@$hostname[$thishost]:/tmp' 2>&1 | grep -v '^\$' > $tmpfl2 2>&1";
      }
    }
    else
    {
      #$cmd = "remsh $hostname[$thishost] 'rcp ${wsnamef}.${dbamon_userid}:/opt/dbamon/bin/download/*${filemask}* temp' 2>&1 | grep -v '^\$' > $tmpfl2 2>&1";
      #---- Major Change - BB 26Oct04 - send to /temp instead of temp
      $cmd = "remsh $hostname[$thishost] 'rcp ${wsnamef}.${dbamon_userid}:/opt/dbamon/bin/download/*${filemask}* /temp' 2>&1 | grep -v '^\$' > $tmpfl2 2>&1";
    }
    &logit("Downloading download files to target - cmd=($cmd)",$thishost);
    $rc = system($cmd);
    &debug($thishost,"rc=$rc cmd=$cmd");
    &logit("Download rc=($rc)",$thishost);

    ##print "HIT-D - rc=$rc\n";  $local_debug=1; 
  }

  #---- New 2016/12/02 - This is much better than all of those slow, expensive system calls
  open(TMPREAD, "$tmpfl2") || &error_msg("Cannot open input tmpfl2=($tmpfl2) - L146 - $!");
  $zreadcnt = 0; 
  while(<TMPREAD>)
  {
    $zreadcnt++; 
    #---- Throw out garbage
    next if /^#/;
    next if /^$/;
    next if /^\s*$/;

    #---- This is for a bug in CopSSH that was fixed.
    ##next if /^Environment:/; 
    ##next if /^\s\s/ && /\=/;

    #---- Check for pw expired error
    if (/expired/i) 
    {
      &event("C",$thishost,"scp/rcp Error - Userid=$userid[$thishost] password expired","DnldPasswd","DBA502C",$tmpfl2);
      $up[$thishost] = "D";
      return;
    }
    if (/disabled'/i) 
    {
      &event("C",$thishost,"scp/rcp Error - Userid=$userid[$thishost] account disabled","DnldAcct","DBA502C",$tmpfl2);
      $up[$thishost] = "D";
      return;
    }
    if (/incorrect/i) 
    {
      &event("C",$thishost,"scp/rcp Error - Userid=$userid[$thishost] login incorrect","DnldIncorr","DBA502C",$tmpfl2);
      $up[$thishost] = "D";
      return;
    }
    if (/lost connection/i) 
    {
      &event("C",$thishost,"scp/rcp Error - Userid=$userid[$thishost] lost connection","DnldLostConn","DBA502C",$tmpfl2);
      $up[$thishost] = "D";
      return;
    }

    #---- If we are this far, then there is some error message that we have not already coded for. Poop the bed. 
    &logit("Download Error: $_",$thishost);
    print "Download Error:\n"; 
    print; 
    &event("C",$thishost,"Undiagnosed scp/rcp Error - Userid=$userid[$thishost]","DnldErrUnk","DBA502C",$tmpfl2);
    $up[$thishost] = "D";
    return;
  } 
  close(TMPREAD); 
  &logit("After probe download - read $zreadcnt lines from SCP output", $thishost); 

  #---- Completion Message
  $download_flag[$thishost] = 1;
  $up[$thishost] = "";
  $hn = $hostname[$thishost];
  $download_host{$hn} = 1;
  
  #---- See which version of COPSSH we're using. If the latest free version, then we need to set sleep for this instance
  if ($using_copssh)
  {
    &logit("CopSSH - Attempting to query BASH_VERSION (sleeping 2 first) ...", $thishost); 
    sleep 2; 
    &remsh("echo \$BASH_VERSION",$tmpfl2,$thishost);
    open(TMPREAD, "$tmpfl2") || &error_msg("Cannot open input tmpfl2=($tmpfl2) - L146 - $!");
    while(<TMPREAD>)
    {
      @zwords = split(/\./,$_);
      $copssh_ver_major = $zwords[0]; 
      &logit("CopSSH - Determining whether or not to sleep before REMSH calls - copssh_ver_major=$copssh_ver_major", $thishost); 
      #---- If this version is > 3, then set 2 second sleep
      if ($copssh_ver_major > 3) 
      {
        ##$remsh_pre_sleep[$thishost] = 2; 
        ##&logit("CopSSH - We will use Pre REMSH Sleep - remsh_pre_sleep=$remsh_pre_sleep[$thishost]", $thishost); 

        $using_copssh_singlethread = 1; 
        &logit("CopSSH - Since we are on the new single-threaded version, I will now sleep 2 to give it time to restart after CopSSH remsh ...", $thishost); 
        sleep 2; 
      }
    }
    close(TMPREAD); 
  }

  #---- Ensure that /usr/local/bin/perl on the db server points to perl5
  &logit("Running PERL verification",$thishost);
  &remsh("$perlpath[$thishost] -v",$tmpfl2,$thishost);
  &debug($thishost, "After perl version check:", 0, $tmpfl2); 

  #---- Read output into var
  open(TMPREAD, "$tmpfl2") || &error_msg("Cannot open input tmpfl2=($tmpfl2) - L223 - $!");
  $tmpfl2_contents = ""; 
  while(<TMPREAD>)
  {
    $tmpfl2_contents .= $_; 
  }
  close(TMPREAD); 
  &debug($thishost, "DEBUG tmpfl2_contents=\n$tmpfl2_contents"); 

  #---- See if we have what we need:
  #----   This is perl 5, version 18, subversion 2 (v5.18.2) built for MSWin32-x64-multi-thread^M
  if (
    $tmpfl2_contents =~ /This is perl, version 5/ || 
    $tmpfl2_contents =~ /This is perl, v5/ || 
    $tmpfl2_contents =~ /This is perl 5/ || 
    $tmpfl2_contents =~ /perl5/
    )
  {
    &logit("We found a good string indicating that this is Perl5", $thishost); 
  }
  else
  {
    if ($tmpfl2_contents =~ /not found/i) 
    {
      $zerr = "Perl Not Found - Check DBC Perl_Path:"; 
    }
    else
    {
      $zerr = "Perl Verify Failed - Undiagnosable"; 
    }
    &event("C",$thishost,"Perl verify failed: $zerr","PerlVer","DBA503C",$tmpfl2);
    $up[$thishost] = "D";
    return;
  }

  #---- Sleep if we're on the singlethreaded version
  if ($using_copssh_singlethread) 
  {
    &logit("CopSSH - Since we are on the new single-threaded version, I will now sleep 2 to give it time to restart after Perl remsh ...", $thishost); 
    sleep 2; 
  }

  #--- Old
  #if (system("egrep 'This is perl, version 5|This is perl, v5|This is perl 5|perl5' $tmpfl2 > /dev/null") != 0)
  #{
  #  if (system("grep 'name specified is not recognized' $tmpfl2 > /dev/null") == 0)
  #  { 
  #    system("echo 'Command Not Found - Check Perl_Path: DBC Parameter' > $tmpfl3");
  #  }
  #  else
  #  {
  #    system("echo 'Perl5 check - Undiagnosable Error:' > $tmpfl3");
  #    system("cat -v $tmpfl2 >> $tmpfl3");
  #  }
  #  &event("C",$thishost,"$perlpath[$thishost] Does Not Invoke Perl Version 5","PerlVer","DBA503C",$tmpfl3);
  #  $up[$thishost] = "D";
  #  return;
  #}

  &logit("OK",$thishost);
  &function_cleanup();
}     
#-------------------------------------------------------------------------------
1;
